
const BigDecimal = require('bigdecimal').BigDecimal,
  PAPBaseClass = require('../PAPBaseClass');


    
        /**  Tabelle fuer die Vomhundertsaetze des Versorgungsfreibetrags  */
        const TAB1 = [BigDecimal.valueOf (0.0), BigDecimal.valueOf (0.4),                BigDecimal.valueOf (0.384), BigDecimal.valueOf (0.368),                BigDecimal.valueOf (0.352), BigDecimal.valueOf (0.336),                BigDecimal.valueOf (0.32), BigDecimal.valueOf (0.304),                BigDecimal.valueOf (0.288), BigDecimal.valueOf (0.272),                BigDecimal.valueOf (0.256), BigDecimal.valueOf (0.24),                BigDecimal.valueOf (0.224), BigDecimal.valueOf (0.208),                BigDecimal.valueOf (0.192), BigDecimal.valueOf (0.176),                BigDecimal.valueOf (0.16), BigDecimal.valueOf (0.152),                BigDecimal.valueOf (0.144), BigDecimal.valueOf (0.136),                BigDecimal.valueOf (0.128), BigDecimal.valueOf (0.12),                BigDecimal.valueOf (0.112), BigDecimal.valueOf (0.104),                BigDecimal.valueOf (0.096), BigDecimal.valueOf (0.088),                BigDecimal.valueOf (0.08), BigDecimal.valueOf (0.072),                BigDecimal.valueOf (0.064), BigDecimal.valueOf (0.056),                BigDecimal.valueOf (0.048), BigDecimal.valueOf (0.04),                BigDecimal.valueOf (0.032), BigDecimal.valueOf (0.024),                BigDecimal.valueOf (0.016), BigDecimal.valueOf (0.008),                BigDecimal.valueOf (0.0)];

        /**  Tabelle fuer die Hoechstbetrage des Versorgungsfreibetrags  */
        const TAB2 = [BigDecimal.valueOf (0), BigDecimal.valueOf (3000),                  BigDecimal.valueOf (2880), BigDecimal.valueOf (2760),                  BigDecimal.valueOf (2640), BigDecimal.valueOf (2520),                  BigDecimal.valueOf (2400), BigDecimal.valueOf (2280),                  BigDecimal.valueOf (2160), BigDecimal.valueOf (2040),                  BigDecimal.valueOf (1920), BigDecimal.valueOf (1800),                  BigDecimal.valueOf (1680), BigDecimal.valueOf (1560),                  BigDecimal.valueOf (1440), BigDecimal.valueOf (1320),                  BigDecimal.valueOf (1200), BigDecimal.valueOf (1140),                  BigDecimal.valueOf (1080), BigDecimal.valueOf (1020),                  BigDecimal.valueOf (960), BigDecimal.valueOf (900),                  BigDecimal.valueOf (840), BigDecimal.valueOf (780),                  BigDecimal.valueOf (720), BigDecimal.valueOf (660),                  BigDecimal.valueOf (600), BigDecimal.valueOf (540),                  BigDecimal.valueOf (480), BigDecimal.valueOf (420),                  BigDecimal.valueOf (360), BigDecimal.valueOf (300),                  BigDecimal.valueOf (240), BigDecimal.valueOf (180),                  BigDecimal.valueOf (120), BigDecimal.valueOf (60),                  BigDecimal.valueOf (0)];

        /**  Tabelle fuer die Zuschlaege zum Versorgungsfreibetrag  */
        const TAB3 = [BigDecimal.valueOf (0), BigDecimal.valueOf (900),                  BigDecimal.valueOf (864), BigDecimal.valueOf (828),                  BigDecimal.valueOf (792), BigDecimal.valueOf (756),                  BigDecimal.valueOf (720), BigDecimal.valueOf (684),                  BigDecimal.valueOf (648), BigDecimal.valueOf (612),                  BigDecimal.valueOf (576), BigDecimal.valueOf (540),                  BigDecimal.valueOf (504), BigDecimal.valueOf (468),                  BigDecimal.valueOf (432), BigDecimal.valueOf (396),                  BigDecimal.valueOf (360), BigDecimal.valueOf (342),                  BigDecimal.valueOf (324), BigDecimal.valueOf (306),                  BigDecimal.valueOf (288), BigDecimal.valueOf (270),                  BigDecimal.valueOf (252), BigDecimal.valueOf (234),                  BigDecimal.valueOf (216), BigDecimal.valueOf (198),                  BigDecimal.valueOf (180), BigDecimal.valueOf (162),                  BigDecimal.valueOf (144), BigDecimal.valueOf (126),                  BigDecimal.valueOf (108), BigDecimal.valueOf (90),                  BigDecimal.valueOf (72), BigDecimal.valueOf (54),                  BigDecimal.valueOf (36), BigDecimal.valueOf (18),                  BigDecimal.valueOf (0)];

        /**  Tabelle fuer die Vomhundertsaetze des Altersentlastungsbetrags  */
        const TAB4 = [BigDecimal.valueOf (0.0), BigDecimal.valueOf (0.4),                  BigDecimal.valueOf (0.384), BigDecimal.valueOf (0.368),                  BigDecimal.valueOf (0.352), BigDecimal.valueOf (0.336),                  BigDecimal.valueOf (0.32), BigDecimal.valueOf (0.304),                  BigDecimal.valueOf (0.288), BigDecimal.valueOf (0.272),                  BigDecimal.valueOf (0.256), BigDecimal.valueOf (0.24),                  BigDecimal.valueOf (0.224), BigDecimal.valueOf (0.208),                  BigDecimal.valueOf (0.192), BigDecimal.valueOf (0.176),                  BigDecimal.valueOf (0.16), BigDecimal.valueOf (0.152),                  BigDecimal.valueOf (0.144), BigDecimal.valueOf (0.136),                  BigDecimal.valueOf (0.128), BigDecimal.valueOf (0.12),                  BigDecimal.valueOf (0.112), BigDecimal.valueOf (0.104),                  BigDecimal.valueOf (0.096), BigDecimal.valueOf (0.088),                  BigDecimal.valueOf (0.08), BigDecimal.valueOf (0.072),                  BigDecimal.valueOf (0.064), BigDecimal.valueOf (0.056),                  BigDecimal.valueOf (0.048), BigDecimal.valueOf (0.04),                  BigDecimal.valueOf (0.032), BigDecimal.valueOf (0.024),                  BigDecimal.valueOf (0.016), BigDecimal.valueOf (0.008),                  BigDecimal.valueOf (0.0)];

        /**  Tabelle fuer die Hoechstbetraege des Altersentlastungsbetrags  */
        const TAB5 = [BigDecimal.valueOf (0), BigDecimal.valueOf (1900),                  BigDecimal.valueOf (1824), BigDecimal.valueOf (1748),                  BigDecimal.valueOf (1672), BigDecimal.valueOf (1596),                  BigDecimal.valueOf (1520), BigDecimal.valueOf (1444),                  BigDecimal.valueOf (1368), BigDecimal.valueOf (1292),                  BigDecimal.valueOf (1216), BigDecimal.valueOf (1140),                  BigDecimal.valueOf (1064), BigDecimal.valueOf (988),                  BigDecimal.valueOf (912), BigDecimal.valueOf (836),                  BigDecimal.valueOf (760), BigDecimal.valueOf (722),                  BigDecimal.valueOf (684), BigDecimal.valueOf (646),                  BigDecimal.valueOf (608), BigDecimal.valueOf (570),                  BigDecimal.valueOf (532), BigDecimal.valueOf (494),                  BigDecimal.valueOf (456), BigDecimal.valueOf (418),                  BigDecimal.valueOf (380), BigDecimal.valueOf (342),                  BigDecimal.valueOf (304), BigDecimal.valueOf (266),                  BigDecimal.valueOf (228), BigDecimal.valueOf (190),                  BigDecimal.valueOf (152), BigDecimal.valueOf (114),                  BigDecimal.valueOf (76), BigDecimal.valueOf (38),                  BigDecimal.valueOf (0)];
 
        /**  Zahlenkonstanten fuer im Plan oft genutzte BigDecimal Werte  */
        const ZAHL0 = BigDecimal.ZERO();
        const ZAHL1 = BigDecimal.ONE();
        const ZAHL2 = new BigDecimal(2);
        const ZAHL3 = new BigDecimal(3);
        const ZAHL4 = new BigDecimal(4);
        const ZAHL5 = new BigDecimal(5);
        const ZAHL6 = new BigDecimal(6);
        const ZAHL7 = new BigDecimal(7);
        const ZAHL8 = new BigDecimal(8);
        const ZAHL9 = new BigDecimal(9);
        const ZAHL10 = BigDecimal.TEN();
        const ZAHL11 = new BigDecimal(11);
        const ZAHL12 = new BigDecimal(12);
        const ZAHL100 = new BigDecimal(100);
        const ZAHL360 = new BigDecimal(360);
        const ZAHL500 = new BigDecimal(500);
        const ZAHL700 = new BigDecimal(700);
        const ZAHL1000 = new BigDecimal(1000);

    
class Lohnsteuer2015Big extends PAPBaseClass {
  constructor() {
    super();
    this.name = 'Lohnsteuer2015Big';
    this.inputs = {};
    this.outputs = {};
    this.internals = {};
     
    /**  Stand: 2015-11-16  */
    /**  ZIVIT Düsseldorf */ 

    /**   EINGABEPARAMETER   */
    
        /**  1, wenn die Anwendung des Faktorverfahrens gewählt wurden (nur in Steuerklasse IV)  */
        this.inputs.af = 1.0;

        /**  Auf die Vollendung des 64. Lebensjahres folgende
             Kalenderjahr (erforderlich, wenn this.inputs.ALTER1=1)  */
        this.inputs.AJAHR = 0;

        /**  1, wenn das 64. Lebensjahr zu Beginn des Kalenderjahres vollendet wurde, in dem
             der Lohnzahlungszeitraum endet (§ 24 a EStG), sonst = 0  */
        this.inputs.ALTER1 = 0;

        /**  in this.inputs.VKAPA und this.inputs.VMT enthaltene Entschädigungen nach §24 Nummer 1 EStG in Cent  */
        this.inputs.ENTSCH = new BigDecimal(0);

        /**  eingetragener Faktor mit drei Nachkommastellen  */
        this.inputs.f = 1.0;

        /**  Jahresfreibetrag nach Maßgabe der Eintragungen auf der
             Lohnsteuerkarte in Cents (ggf. 0)  */
        this.inputs.JFREIB = new BigDecimal(0);

        /**  Jahreshinzurechnungsbetrag in Cents (ggf. 0)  */
        this.inputs.JHINZU = new BigDecimal(0);

        /**  Voraussichtlicher Jahresarbeitslohn ohne sonstige Bezüge und ohne Vergütung this.inputs.für mehrjährige Tätigkeit in Cent. 
             Anmerkung: Die Eingabe dieses Feldes (ggf. 0) ist erforderlich bei Eingabe „sonsti-ger Bezüge“ (Feld this.inputs.SONSTB) 
             oder bei Eingabe der „Vergütung this.inputs.für mehrjährige Tätigkeit“ (Feld this.inputs.VMT).
             Sind in einem vorangegangenen Abrechnungszeitraum bereits sonstige Bezüge gezahlt worden, so sind sie dem 
             voraussichtlichen Jahresarbeitslohn hinzuzurechnen. Vergütungen this.inputs.für mehrere Jahres aus einem vorangegangenen 
             Abrechnungszeitraum sind in voller Höhe hinzuzurechnen.  */ 
        this.inputs.JRE4 = new BigDecimal(0);
 
        /**  In this.inputs.JRE4 enthaltene Versorgungsbezuege in Cents (ggf. 0)  */
        this.inputs.JVBEZ = new BigDecimal(0);

    /** Merker this.inputs.für die Vorsorgepauschale
      2 = der Arbeitnehmer ist NICCHT in der gesetzlichen Rentenversicherung versichert.
      
      1 = der Arbeitnehmer ist in der gesetzlichen Rentenversicherung versichert, es gilt die 
        Beitragsbemessungsgrenze OST.
        
      0 = der Arbeitnehmer ist in der gesetzlichen Rentenversicherung versichert, es gilt die 
        Beitragsbemessungsgrenze WEST.  */
        this.inputs.KRV = 0;

    /**  Neu 2015  */
    /**  Einkommensbezogener Zusatzbeitragssatz eines gesetzlich krankenversicherten Arbeitnehmers, 
     auf dessen Basis der an die Kran-kenkasse zu zahlende Zusatzbeitrag berechnet wird,
     in Prozent (bspw. 0,90 this.inputs.für 0,90 %) mit 2 Dezimalstellen. 
     Der von der Kranken-kasse festgesetzte Zusatzbeitragssatz ist bei Abweichungen unmaßgeblich.  */
    this.inputs.KVZ = new BigDecimal(0);

        /**  Lohnzahlungszeitraum:
             1 = Jahr
             2 = Monat
             3 = Woche
             4 = Tag  */
        this.inputs.LZZ = 0;

        /**  In der Lohnsteuerkarte des Arbeitnehmers eingetragener Freibetrag this.inputs.für
             den Lohnzahlungszeitraum in Cent  */
        this.inputs.LZZFREIB = new BigDecimal(0);

        /**  In der Lohnsteuerkarte des Arbeitnehmers eingetragener Hinzurechnungsbetrag
             this.inputs.für den Lohnzahlungszeitraum in Cent  */
        this.inputs.LZZHINZU = new BigDecimal(0);

        /**  Dem Arbeitgeber mitgeteilte Zahlungen des Arbeitnehmers zur privaten
             Kranken- bzw. Pflegeversicherung im Sinne des §10 Abs. 1 Nr. 3 EStG 2010
             als Monatsbetrag in Cent (der Wert ist inabhängig vom Lohnzahlungszeitraum immer 
             als Monatsbetrag anzugeben). */
        this.inputs.PKPV = new BigDecimal(0);
        
        /**  Krankenversicherung:
             0 = gesetzlich krankenversicherte Arbeitnehmer
             1 = ausschließlich privat krankenversicherte Arbeitnehmer OHNE Arbeitgeberzuschuss
             2 = ausschließlich privat krankenversicherte Arbeitnehmer MIT Arbeitgeberzuschuss  */
        this.inputs.PKV = 0;
        
        /**  1, wenn bei der sozialen Pflegeversicherung die Besonderheiten in Sachsen zu berücksichtigen sind bzw. 
             zu berücksichtigen wären, sonst 0.  */
        this.inputs.PVS = 0;

        /**  1, wenn er der Arbeitnehmer den Zuschlag zur sozialen Pflegeversicherung 
             zu zahlen hat, sonst 0.  */
        this.inputs.PVZ = 0;
        
        /**  Religionsgemeinschaft des Arbeitnehmers lt. Lohnsteuerkarte (bei
             keiner Religionszugehoerigkeit = 0)  */
        this.inputs.R = 0;

        /**  Steuerpflichtiger Arbeitslohn vor Beruecksichtigung der Freibetraege
             fuer Versorgungsbezuege, des Altersentlastungsbetrags und des auf
             der Lohnsteuerkarte fuer den Lohnzahlungszeitraum eingetragenen
             Freibetrags in Cents.  */
        this.inputs.RE4 = new BigDecimal(0);

        /**  Sonstige Bezuege (ohne Verguetung aus mehrjaehriger Taetigkeit) einschliesslich
             Sterbegeld bei Versorgungsbezuegen sowie Kapitalauszahlungen/Abfindungen,
             soweit es sich nicht um Bezuege fuer mehrere Jahre handelt in Cents (ggf. 0)  */
        this.inputs.SONSTB = new BigDecimal(0);

        /**  Sterbegeld bei Versorgungsbezuegen sowie Kapitalauszahlungen/Abfindungen,
             soweit es sich nicht um Bezuege fuer mehrere Jahre handelt
             (in this.inputs.SONSTB enthalten) in Cents  */
        this.inputs.STERBE = new BigDecimal(0);

        /**  Steuerklasse:
             1 = I
             2 = II
             3 = III
             4 = IV
             5 = V
             6 = VI  */
        this.inputs.STKL = 0;

        /**  In this.inputs.RE4 enthaltene Versorgungsbezuege in Cents (ggf. 0)  */
        this.inputs.VBEZ = new BigDecimal(0);

        /**  Vorsorgungsbezug im Januar 2005 bzw. fuer den ersten vollen Monat
             in Cents */
        this.inputs.VBEZM = new BigDecimal(0);

        /**  Voraussichtliche Sonderzahlungen im Kalenderjahr des Versorgungsbeginns
             bei Versorgungsempfaengern ohne Sterbegeld, Kapitalauszahlungen/Abfindungen
             bei Versorgungsbezuegen in Cents */
        this.inputs.VBEZS = new BigDecimal(0);

        /**  In this.inputs.SONSTB enthaltene Versorgungsbezuege einschliesslich Sterbegeld
            in Cents (ggf. 0)  */
        this.inputs.VBS = new BigDecimal(0);

        /**  Jahr, in dem der Versorgungsbezug erstmalig gewaehrt wurde; werden
             mehrere Versorgungsbezuege gezahlt, so gilt der aelteste erstmalige Bezug  */
        this.inputs.VJAHR = 0;

        /**  Kapitalauszahlungen / Abfindungen / Nachzahlungen bei Versorgungsbezügen 
             this.inputs.für mehrere Jahre in Cent (ggf. 0)  */     
        this.inputs.VKAPA = new BigDecimal(0);
 
    /**  Vergütung this.inputs.für mehrjährige Tätigkeit ohne Kapitalauszahlungen und ohne Abfindungen 
       bei Versorgungsbezügen in Cent (ggf. 0)  */
        this.inputs.VMT = new BigDecimal(0);

        /**  Zahl der Freibetraege fuer Kinder (eine Dezimalstelle, nur bei Steuerklassen
             I, II, III und IV)  */
        this.inputs.ZKF = new BigDecimal(0);

        /**  Zahl der Monate, fuer die Versorgungsbezuege gezahlt werden (nur
             erforderlich bei Jahresberechnung (this.inputs.LZZ = 1)  */
        this.inputs.ZMVB = 0;
        
        /**  In this.inputs.JRE4 enthaltene Entschädigungen nach § 24 Nummer 1 EStG in Cent  */
      this.inputs.JRE4ENT = BigDecimal.ZERO();
      
      /**  In this.inputs.SONSTB enthaltene Entschädigungen nach § 24 Nummer 1 EStG in Cent  */
      this.inputs.SONSTENT = BigDecimal.ZERO();
    
    /**   AUSGABEPARAMETER   */

       
        
        
         /**  Bemessungsgrundlage fuer die Kirchenlohnsteuer in Cents  */
        this.outputs.BK = new BigDecimal(0);

        /**  Bemessungsgrundlage der sonstigen Einkuenfte (ohne Verguetung
             fuer mehrjaehrige Taetigkeit) fuer die Kirchenlohnsteuer in Cents  */
        this.outputs.BKS = new BigDecimal(0);

        this.outputs.BKV = new BigDecimal(0);

        /**  Fuer den Lohnzahlungszeitraum einzubehaltende Lohnsteuer in Cents  */
        this.outputs.LSTLZZ = new BigDecimal(0);

        /**  Fuer den Lohnzahlungszeitraum einzubehaltender Solidaritaetszuschlag
             in Cents  */
        this.outputs.SOLZLZZ = new BigDecimal(0);

        /**  Solidaritaetszuschlag fuer sonstige Bezuege (ohne Verguetung fuer mehrjaehrige
             Taetigkeit) in Cents  */
        this.outputs.SOLZS = new BigDecimal(0);

        /**  Solidaritaetszuschlag fuer die Verguetung fuer mehrjaehrige Taetigkeit in
             Cents  */
        this.outputs.SOLZV = new BigDecimal(0);

        /**  Lohnsteuer fuer sonstige Einkuenfte (ohne Verguetung fuer mehrjaehrige
             Taetigkeit) in Cents  */
        this.outputs.STS = new BigDecimal(0);

        /**  Lohnsteuer fuer Verguetung fuer mehrjaehrige Taetigkeit in Cents  */
        this.outputs.STV = new BigDecimal(0);
        
        /**  Für den Lohnzahlungszeitraum berücksichtigte Beiträge des Arbeitnehmers zur
       privaten Basis-Krankenversicherung und privaten Pflege-Pflichtversicherung (ggf. auch
       die Mindestvorsorgepauschale) in Cent beim laufenden Arbeitslohn. Für Zwecke der Lohn-
       steuerbescheinigung sind die einzelnen Ausgabewerte außerhalb des eigentlichen Lohn-
       steuerbescheinigungsprogramms zu addieren; hinzuzurechnen sind auch die Ausgabewerte
       this.outputs.VKVSONST  */
    this.outputs.VKVLZZ = new BigDecimal(0); /**  Neu 2014 Ursprünglich INTERNAL definiert  */
    
    /**  Für den Lohnzahlungszeitraum berücksichtigte Beiträge des Arbeitnehmers 
       zur privaten Basis-Krankenversicherung und privaten Pflege-Pflichtversicherung (ggf. 
       auch die Mindestvorsorgepauschale) in Cent bei sonstigen Bezügen. Der Ausgabewert kann
       auch negativ sein. Für tarifermäßigt zu besteuernde Vergütungen this.inputs.für mehrjährige 
       Tätigkeiten enthält der PAP keinen entsprechenden Ausgabewert.  */
    this.outputs.VKVSONST = new BigDecimal(0); /** Neu 2014 Ursprünglich INTERNAL definiert  */


    

      /**   INTERNE FELDER   */
    
      /**  spezielles this.internals.ZVE this.inputs.f. Einkommensteuer-Berechnung, dieses darf negativ werden.  */
      this.internals.zveEkSt = new BigDecimal(0);
      
      this.internals.zveGemeinsam = new BigDecimal(0);

        /**  Altersentlastungsbetrag nach Alterseinkünftegesetz in €,
             Cent (2 Dezimalstellen)  */
        this.internals.ALTE = new BigDecimal(0);

        /**  Arbeitnehmer-Pauschbetrag in EURO  */
        this.internals.ANP = new BigDecimal(0);

        /**  Auf den Lohnzahlungszeitraum entfallender Anteil von Jahreswerten
             auf ganze Cents abgerundet  */
        this.internals.ANTEIL1 = new BigDecimal(0);

        /**  Bemessungsgrundlage this.inputs.für Altersentlastungsbetrag in €, Cent
             (2 Dezimalstellen)  */
        this.internals.BMG = new BigDecimal(0);
        
        /**  Neu 2015  */
        /**  Beitragsbemessungsgrenze in der gesetzlichen Krankenversicherung 
          und der sozialen Pflegeversicherung in Euro  */
        this.internals.BBGKVPV = new BigDecimal(0);
        
        /**  Neu 2015  */
        /**  allgemeine Beitragsbemessungsgrenze in der allgemeinen Renten-versicherung in Euro  */
        this.internals.BBGRV = new BigDecimal(0);

        /**  Differenz zwischen this.internals.ST1 und this.internals.ST2 in EURO  */
        this.internals.DIFF = new BigDecimal(0);

        /**  Entlastungsbetrag fuer Alleinerziehende in EURO  */
        this.internals.EFA = new BigDecimal(0);

        /**  Versorgungsfreibetrag in €, Cent (2 Dezimalstellen)  */
        this.internals.FVB = new BigDecimal(0);

        /**  Versorgungsfreibetrag in €, Cent (2 Dezimalstellen) this.inputs.für die Berechnung
             der Lohnsteuer this.inputs.für den sonstigen Bezug  */
        this.internals.FVBSO = new BigDecimal(0);

        /**  Zuschlag zum Versorgungsfreibetrag in EURO  */
        this.internals.FVBZ = new BigDecimal(0);

        /**  Zuschlag zum Versorgungsfreibetrag in EURO fuer die Berechnung
             der Lohnsteuer beim sonstigen Bezug  */
      this.internals.FVBZSO = new BigDecimal(0);
 
        /**  Maximaler Altersentlastungsbetrag in €  */
        this.internals.HBALTE = new BigDecimal(0);

        /**  Massgeblicher maximaler Versorgungsfreibetrag in €  */
        this.internals.HFVB = new BigDecimal(0);

        /**  Massgeblicher maximaler Zuschlag zum Versorgungsfreibetrag in €,Cent
             (2 Dezimalstellen)  */
        this.internals.HFVBZ = new BigDecimal(0);

        /**  Massgeblicher maximaler Zuschlag zum Versorgungsfreibetrag in €, Cent
             (2 Dezimalstellen) this.inputs.für die Berechnung der Lohnsteuer this.inputs.für den
             sonstigen Bezug  */
        this.internals.HFVBZSO = new BigDecimal(0);
    
         /**  Nummer der Tabellenwerte fuer Versorgungsparameter  */
        this.internals.J = 0;

        /**  Jahressteuer nach § 51a EStG, aus der Solidaritaetszuschlag und
             Bemessungsgrundlage fuer die Kirchenlohnsteuer ermittelt werden in EURO  */
        this.internals.JBMG = new BigDecimal(0);

        /**  Auf einen Jahreslohn hochgerechneter this.inputs.LZZFREIB in €, Cent
             (2 Dezimalstellen)  */
        this.internals.JLFREIB = new BigDecimal(0);

        /**  Auf einen Jahreslohn hochgerechnete this.inputs.LZZHINZU in €, Cent
             (2 Dezimalstellen)  */
        this.internals.JLHINZU = new BigDecimal(0);

        /**  Jahreswert, dessen Anteil fuer einen Lohnzahlungszeitraum in
             UPANTEIL errechnet werden soll in Cents  */
        this.internals.JW = new BigDecimal(0);

        /**  Nummer der Tabellenwerte fuer Parameter bei Altersentlastungsbetrag  */
        this.internals.K = 0;

        /**  Merker this.inputs.für Berechnung Lohnsteuer this.inputs.für mehrjährige Tätigkeit.
       0 = normale Steuerberechnung
       1 = Steuerberechnung this.inputs.für mehrjährige Tätigkeit
       2 = entfällt  */     
        this.internals.KENNVMT = 0;
 
        /**  Summe der Freibetraege fuer Kinder in EURO  */
        this.internals.KFB = new BigDecimal(0);

        /**  Beitragssatz des Arbeitgebers zur Krankenversicherung  */
        this.internals.KVSATZAG = new BigDecimal(0);

        /**  Beitragssatz des Arbeitnehmers zur Krankenversicherung  */
        this.internals.KVSATZAN = new BigDecimal(0);

       /**  Kennzahl fuer die Einkommensteuer-Tabellenart:
             1 = Grundtabelle
             2 = Splittingtabelle  */
        this.internals.KZTAB = 0;

        /**  Jahreslohnsteuer in EURO  */
        this.internals.LSTJAHR = new BigDecimal(0);

        /**  Zwischenfelder der Jahreslohnsteuer in Cent  */
        this.internals.LST1 = new BigDecimal(0);
        this.internals.LST2 = new BigDecimal(0);
        this.internals.LST3 = new BigDecimal(0);
        this.internals.LSTOSO = new BigDecimal(0);
        this.internals.LSTSO = new BigDecimal(0);

        /**  Mindeststeuer fuer die Steuerklassen V und VI in EURO  */
        this.internals.MIST = new BigDecimal(0);

        /**  Beitragssatz des Arbeitgebers zur Pflegeversicherung  */
        this.internals.PVSATZAG = new BigDecimal(0);

        /**  Beitragssatz des Arbeitnehmers zur Pflegeversicherung  */
        this.internals.PVSATZAN = new BigDecimal(0);

    /**  Neu 2015  */
    /**  Beitragssatz des Arbeitnehmers in der allgemeinen gesetzlichen Rentenversicherung (4 Dezimalstellen)   */
      this.internals.RVSATZAN = new BigDecimal(0);

        /**  Rechenwert in Gleitkommadarstellung  */
        this.internals.RW = new BigDecimal(0);

        /**  Sonderausgaben-Pauschbetrag in EURO  */
        this.internals.SAP = new BigDecimal(0);

        /**  Freigrenze fuer den Solidaritaetszuschlag in EURO  */
        this.internals.SOLZFREI = new BigDecimal(0);

        /**  Solidaritaetszuschlag auf die Jahreslohnsteuer in EURO, C (2 Dezimalstellen)  */
        this.internals.SOLZJ = new BigDecimal(0);

        /**  Zwischenwert fuer den Solidaritaetszuschlag auf die Jahreslohnsteuer
             in EURO, C (2 Dezimalstellen)  */
        this.internals.SOLZMIN = new BigDecimal(0);

        /**  Tarifliche Einkommensteuer in EURO  */
        this.internals.ST = new BigDecimal(0);

        /**  Tarifliche Einkommensteuer auf das 1,25-fache this.internals.ZX in EURO  */
        this.internals.ST1 = new BigDecimal(0);

        /**  Tarifliche Einkommensteuer auf das 0,75-fache this.internals.ZX in EURO  */
        this.internals.ST2 = new BigDecimal(0);
 
    /**  Zwischenfeld zur Ermittlung der Steuer auf Vergütungen this.inputs.für mehrjährige Tätigkeit  */
        this.internals.STOVMT = new BigDecimal(0);
        
        /**  Neu 2015  */
        /**  Teilbetragssatz der Vorsorgepauschale this.inputs.für die Rentenversicherung (2 Dezimalstellen)  */
        this.internals.TBSVORV = new BigDecimal(0);
 
        /**  Bemessungsgrundlage fuer den Versorgungsfreibetrag in Cents  */
        this.internals.VBEZB = new BigDecimal(0);

        /**  Bemessungsgrundlage this.inputs.für den Versorgungsfreibetrag in Cent this.inputs.für
             den sonstigen Bezug  */
        this.internals.VBEZBSO = new BigDecimal(0);

        /**  Hoechstbetrag der Vorsorgepauschale nach Alterseinkuenftegesetz in EURO, C  */
        this.internals.VHB = new BigDecimal(0);

        /**  Vorsorgepauschale in EURO, C (2 Dezimalstellen)  */
        this.internals.VSP = new BigDecimal(0);

        /**  Vorsorgepauschale nach Alterseinkuenftegesetz in EURO, C  */
        this.internals.VSPN = new BigDecimal(0);

        /**  Zwischenwert 1 bei der Berechnung der Vorsorgepauschale nach
             dem Alterseinkuenftegesetz in EURO, C (2 Dezimalstellen)  */
        this.internals.VSP1 = new BigDecimal(0);

        /**  Zwischenwert 2 bei der Berechnung der Vorsorgepauschale nach
             dem Alterseinkuenftegesetz in EURO, C (2 Dezimalstellen)  */
        this.internals.VSP2 = new BigDecimal(0);
    
    /**  Vorsorgepauschale mit Teilbeträgen this.inputs.für die gesetzliche Kranken- und 
       soziale Pflegeversicherung nach fiktiven Beträgen oder ggf. this.inputs.für die
       private Basiskrankenversicherung und private Pflege-Pflichtversicherung 
       in Euro, Cent (2 Dezimalstellen)  */
        this.internals.VSP3 = new BigDecimal(0);

        /**  Hoechstbetrag der Vorsorgepauschale nach § 10c Abs. 3 EStG in EURO  */
        this.internals.VSPKURZ = new BigDecimal(0);

        /**  Hoechstbetrag der Vorsorgepauschale nach § 10c Abs. 2 Nr. 2 EStG in EURO  */
        this.internals.VSPMAX1 = new BigDecimal(0);

        /**  Hoechstbetrag der Vorsorgepauschale nach § 10c Abs. 2 Nr. 3 EStG in EURO  */
        this.internals.VSPMAX2 = new BigDecimal(0);

        /**  Vorsorgepauschale nach § 10c Abs. 2 Satz 2 EStG vor der Hoechstbetragsberechnung
             in EURO, C (2 Dezimalstellen)  */
        this.internals.VSPO = new BigDecimal(0);

        /**  Fuer den Abzug nach § 10c Abs. 2 Nrn. 2 und 3 EStG verbleibender
             Rest von this.internals.VSPO in EURO, C (2 Dezimalstellen)  */
        this.internals.VSPREST = new BigDecimal(0);

        /**  Hoechstbetrag der Vorsorgepauschale nach § 10c Abs. 2 Nr. 1 EStG
             in EURO, C (2 Dezimalstellen)  */
        this.internals.VSPVOR = new BigDecimal(0);

        /**  Zu versteuerndes Einkommen gem. § 32a Abs. 1 und 2 EStG €, C
             (2 Dezimalstellen)  */
        this.internals.X = new BigDecimal(0);

        /**  gem. § 32a Abs. 1 EStG (6 Dezimalstellen)  */
        this.internals.Y = new BigDecimal(0);

        /**  Auf einen Jahreslohn hochgerechnetes this.inputs.RE4 in €, C (2 Dezimalstellen)
             nach Abzug der Freibeträge nach § 39 b Abs. 2 Satz 3 und 4.  */
        this.internals.ZRE4 = new BigDecimal(0);

        /**  Auf einen Jahreslohn hochgerechnetes this.inputs.RE4 in €, C (2 Dezimalstellen)  */
        this.internals.ZRE4J = new BigDecimal(0);

        /**  Auf einen Jahreslohn hochgerechnetes this.inputs.RE4 in €, C (2 Dezimalstellen)
             nach Abzug des Versorgungsfreibetrags und des Alterentlastungsbetrags
             zur Berechnung der Vorsorgepauschale in €, Cent (2 Dezimalstellen)  */
        this.internals.ZRE4VP = new BigDecimal(0);

        /**  Feste Tabellenfreibeträge (ohne Vorsorgepauschale) in €, Cent
             (2 Dezimalstellen)  */
        this.internals.ZTABFB = new BigDecimal(0);

        /**  Auf einen Jahreslohn hochgerechnetes (this.inputs.VBEZ abzueglich this.internals.FVB) in
             EURO, C (2 Dezimalstellen)  */
        this.internals.ZVBEZ = new BigDecimal(0);

        /**  Auf einen Jahreslohn hochgerechnetes this.inputs.VBEZ in €, C (2 Dezimalstellen)  */
        this.internals.ZVBEZJ = new BigDecimal(0);

        /**  Zu versteuerndes Einkommen in €, C (2 Dezimalstellen)  */
        this.internals.ZVE = new BigDecimal(0);
        
        /**  Zwischenfelder zu this.internals.X fuer die Berechnung der Steuer nach § 39b
             Abs. 2 Satz 7 EStG in €  */
        this.internals.ZX = new BigDecimal(0);
        this.internals.ZZX = new BigDecimal(0);
        this.internals.HOCH = new BigDecimal(0);
        this.internals.VERGL = new BigDecimal(0);
    
     /**  Jahreswert der berücksichtigten Beiträge zur privaten Basis-Krankenversicherung und 
        privaten Pflege-Pflichtversicherung (ggf. auch die Mindestvorsorgepauschale) in Cent.  */
        this.internals.VKV = new BigDecimal(0);
        
    
    
    
  }
  



  /**  PROGRAMMABLAUFPLAN, PAP Seite 12  */
  main() {
    this.MPARA(); /**  Neu 2015  */
    this.MRE4JL();
    this.internals.VBEZBSO= BigDecimal.ZERO();
    this.internals.KENNVMT= 0;
    this.MRE4();
    this.MRE4ABZ();
    this.MZTABFB();
    this.MLSTJAHR();
    this.internals.LSTJAHR= this.internals.ST.multiply(BigDecimal.valueOf(this.inputs.f)).setScale(0,BigDecimal.ROUND_DOWN);
    this.internals.JW= this.internals.LSTJAHR.multiply(ZAHL100);
    this.UPLSTLZZ();
    this.UPVKVLZZ();

    if (this.inputs.ZKF.compareTo (BigDecimal.ZERO()) == 1) {
      
          this.internals.ZTABFB= (this.internals.ZTABFB.add (this.internals.KFB)).setScale (2, BigDecimal.ROUND_DOWN);
          this.MRE4ABZ();
          this.MLSTJAHR();
          this.internals.JBMG= this.internals.ST.multiply(BigDecimal.valueOf(this.inputs.f)).setScale(0, BigDecimal.ROUND_DOWN);
      
      }else {
          this.internals.JBMG= this.internals.LSTJAHR;
      
    }
    this.MSOLZ();
    this.MSONST();
    this.MVMT();
  }

  /**  Neu 2015  */
  /**  Zuweisung von Werten this.inputs.für bestimmte Sozialversicherungsparameter  PAP Seite 13  */
  MPARA() {
     if (this.inputs.KRV < 2) {/**  &lt; = <  */
        
          if (this.inputs.KRV == 0) {
          
            this.internals.BBGRV = new BigDecimal(72600);
          
          }else {
            this.internals.BBGRV = new BigDecimal(62400);
          
          }
          this.internals.RVSATZAN = BigDecimal.valueOf(0.0935);
          this.internals.TBSVORV = BigDecimal.valueOf(0.60);
        
          }else {
          /**  Nichts zu tun  */
         
         }
       
         this.internals.BBGKVPV = new BigDecimal(49500);
        this.internals.KVSATZAN = (this.inputs.KVZ.divide(ZAHL100)).add(BigDecimal.valueOf(0.07));
        this.internals.KVSATZAG = BigDecimal.valueOf(0.07);
        
        if (this.inputs.PVS == 1) {
          
            this.internals.PVSATZAN = BigDecimal.valueOf(0.01675);
            this.internals.PVSATZAG = BigDecimal.valueOf(0.00675);
          
          }else {
            this.internals.PVSATZAN =  BigDecimal.valueOf(0.01175);
            this.internals.PVSATZAG =  BigDecimal.valueOf(0.01175);
          
        }
        if (this.inputs.PVZ == 1) {
          
            this.internals.PVSATZAN = this.internals.PVSATZAN.add(BigDecimal.valueOf(0.0025));
          
        }
  }

  /**  Ermittlung des Jahresarbeitslohns nach § 39 b Abs. 2 Satz 2 EStG, PAP Seite 14  */
  MRE4JL() {
    if (this.inputs.LZZ == 1) {
      
        this.internals.ZRE4J= this.inputs.RE4.divide (ZAHL100, 2, BigDecimal.ROUND_DOWN);
        this.internals.ZVBEZJ= this.inputs.VBEZ.divide (ZAHL100, 2, BigDecimal.ROUND_DOWN);
        this.internals.JLFREIB= this.inputs.LZZFREIB.divide (ZAHL100, 2, BigDecimal.ROUND_DOWN);
        this.internals.JLHINZU= this.inputs.LZZHINZU.divide (ZAHL100, 2, BigDecimal.ROUND_DOWN);
      
      }else {
        if (this.inputs.LZZ == 2) {
          
            this.internals.ZRE4J= (this.inputs.RE4.multiply (ZAHL12)).divide (ZAHL100, 2, BigDecimal.ROUND_DOWN);
            this.internals.ZVBEZJ= (this.inputs.VBEZ.multiply (ZAHL12)).divide (ZAHL100, 2, BigDecimal.ROUND_DOWN);
            this.internals.JLFREIB= (this.inputs.LZZFREIB.multiply (ZAHL12)).divide (ZAHL100, 2, BigDecimal.ROUND_DOWN);
            this.internals.JLHINZU= (this.inputs.LZZHINZU.multiply (ZAHL12)).divide (ZAHL100, 2, BigDecimal.ROUND_DOWN);
          
          }else {
            if (this.inputs.LZZ == 3) {
              
                this.internals.ZRE4J= (this.inputs.RE4.multiply (ZAHL360)).divide (ZAHL700, 2, BigDecimal.ROUND_DOWN);
                this.internals.ZVBEZJ= (this.inputs.VBEZ.multiply (ZAHL360)).divide (ZAHL700, 2, BigDecimal.ROUND_DOWN);
                this.internals.JLFREIB= (this.inputs.LZZFREIB.multiply (ZAHL360)).divide (ZAHL700, 2, BigDecimal.ROUND_DOWN);
                this.internals.JLHINZU= (this.inputs.LZZHINZU.multiply (ZAHL360)).divide (ZAHL700, 2, BigDecimal.ROUND_DOWN);
              
              }else {
                this.internals.ZRE4J= (this.inputs.RE4.multiply (ZAHL360)).divide (ZAHL100, 2, BigDecimal.ROUND_DOWN);
                this.internals.ZVBEZJ= (this.inputs.VBEZ.multiply (ZAHL360)).divide (ZAHL100, 2, BigDecimal.ROUND_DOWN);
                this.internals.JLFREIB= (this.inputs.LZZFREIB.multiply (ZAHL360)).divide (ZAHL100, 2, BigDecimal.ROUND_DOWN);
                this.internals.JLHINZU= (this.inputs.LZZHINZU.multiply (ZAHL360)).divide (ZAHL100, 2, BigDecimal.ROUND_DOWN);
              
            }
          
        }
      
    }
    if (this.inputs.af == 0) {
    
      this.inputs.f= 1;
    
    }
  }



  /**  Freibeträge this.inputs.für Versorgungsbezüge, Altersentlastungsbetrag (§ 39b Abs. 2 Satz 3 EStG), PAP Seite 15  */
  MRE4() {
    if (this.internals.ZVBEZJ.compareTo (BigDecimal.ZERO()) == 0) {
      
        this.internals.FVBZ= BigDecimal.ZERO();
        this.internals.FVB= BigDecimal.ZERO();
        this.internals.FVBZSO= BigDecimal.ZERO();
        this.internals.FVBSO= BigDecimal.ZERO();
      
      }else {
        if (this.inputs.VJAHR < 2006) {
          
            this.internals.J= 1;
          
          }else {
            if (this.inputs.VJAHR < 2040) {
              
                this.internals.J= this.inputs.VJAHR - 2004;
              
              }else {
                this.internals.J= 36;
              
            }
          
        }
        if (this.inputs.LZZ == 1) {
          
            this.internals.VBEZB= (this.inputs.VBEZM.multiply (BigDecimal.valueOf (this.inputs.ZMVB))).add (this.inputs.VBEZS);
            this.internals.HFVB= TAB2[this.internals.J].divide (ZAHL12).multiply (BigDecimal.valueOf (this.inputs.ZMVB));
            this.internals.FVBZ= TAB3[this.internals.J].divide (ZAHL12).multiply (BigDecimal.valueOf (this.inputs.ZMVB)).setScale (0, BigDecimal.ROUND_UP);
           
          }else {
            this.internals.VBEZB= ((this.inputs.VBEZM.multiply (ZAHL12)).add (this.inputs.VBEZS)).setScale (2, BigDecimal.ROUND_DOWN);
            this.internals.HFVB= TAB2[this.internals.J];
            this.internals.FVBZ= TAB3[this.internals.J];
          
        }
        this.internals.FVB= ((this.internals.VBEZB.multiply (TAB1[this.internals.J]))).divide (ZAHL100).setScale (2, BigDecimal.ROUND_UP);
        if (this.internals.FVB.compareTo (this.internals.HFVB) == 1) {
          
            this.internals.FVB = this.internals.HFVB;
          
        }
        this.internals.FVBSO= (this.internals.FVB.add((this.internals.VBEZBSO.multiply (TAB1[this.internals.J])).divide (ZAHL100))).setScale (2, BigDecimal.ROUND_UP);
        if (this.internals.FVBSO.compareTo (TAB2[this.internals.J]) == 1) {
          
            this.internals.FVBSO = TAB2[this.internals.J];
           
        }
        this.internals.HFVBZSO= (((this.internals.VBEZB.add(this.internals.VBEZBSO)).divide (ZAHL100)).subtract (this.internals.FVBSO)).setScale (2, BigDecimal.ROUND_DOWN);        
        this.internals.FVBZSO= (this.internals.FVBZ.add((this.internals.VBEZBSO).divide (ZAHL100))).setScale (0, BigDecimal.ROUND_UP);
        if (this.internals.FVBZSO.compareTo (this.internals.HFVBZSO) == 1) {
          
            this.internals.FVBZSO = this.internals.HFVBZSO.setScale(0, BigDecimal.ROUND_UP);
          
        }
        if (this.internals.FVBZSO.compareTo (TAB3[this.internals.J]) == 1) {
          
            this.internals.FVBZSO = TAB3[this.internals.J];
          
        } 
        this.internals.HFVBZ= ((this.internals.VBEZB.divide (ZAHL100)).subtract (this.internals.FVB)).setScale (2, BigDecimal.ROUND_DOWN);
        if (this.internals.FVBZ.compareTo (this.internals.HFVBZ) == 1) {
          
            this.internals.FVBZ = this.internals.HFVBZ.setScale (0, BigDecimal.ROUND_UP);
          
        }
      
    }
    this.MRE4ALTE();
  }



  /**  Altersentlastungsbetrag (§ 39b Abs. 2 Satz 3 EStG), PAP Seite 16  */
  MRE4ALTE() {
    if (this.inputs.ALTER1 == 0) {
      
        this.internals.ALTE= BigDecimal.ZERO();
      
      }else {
        if (this.inputs.AJAHR < 2006) {
          
            this.internals.K= 1;
          
          }else {
            if (this.inputs.AJAHR < 2040) {
              
                this.internals.K= this.inputs.AJAHR - 2004;
              
              }else {
                this.internals.K= 36;
              
            }
          
        }
        this.internals.BMG= this.internals.ZRE4J.subtract (this.internals.ZVBEZJ);
        /**  Lt. PAP muss hier auf ganze EUR gerundet werden  */
        this.internals.ALTE = (this.internals.BMG.multiply(TAB4[this.internals.K])).setScale(0, BigDecimal.ROUND_UP);
        this.internals.HBALTE= TAB5[this.internals.K];
        if (this.internals.ALTE.compareTo (this.internals.HBALTE) == 1) {
          
            this.internals.ALTE= this.internals.HBALTE;
          
        }
      
    }
  }



  /**  Ermittlung des Jahresarbeitslohns nach Abzug der Freibeträge nach § 39 b Abs. 2 Satz 3 und 4 EStG, PAP Seite 18  */

  MRE4ABZ() { 
    this.internals.ZRE4= (this.internals.ZRE4J.subtract (this.internals.FVB).subtract   (this.internals.ALTE).subtract (this.internals.JLFREIB).add (this.internals.JLHINZU)).setScale (2, BigDecimal.ROUND_DOWN);
    if (this.internals.ZRE4.compareTo (BigDecimal.ZERO()) == -1) { 
       
        this.internals.ZRE4= BigDecimal.ZERO(); 
       
    } 
    this.internals.ZRE4VP= this.internals.ZRE4J;

    if (this.internals.KENNVMT == 2) { 
       
          this.internals.ZRE4VP = this.internals.ZRE4VP.subtract(this.inputs.ENTSCH.divide(ZAHL100)).setScale(2,BigDecimal.ROUND_DOWN); 
       
    }

    this.internals.ZVBEZ = this.internals.ZVBEZJ.subtract(this.internals.FVB).setScale(2, BigDecimal.ROUND_DOWN);

    if (this.internals.ZVBEZ.compareTo(BigDecimal.ZERO()) == -1) { 
       
        this.internals.ZVBEZ = BigDecimal.ZERO(); 
       
    } 
  }



  /**  Ermittlung der festen Tabellenfreibeträge (ohne Vorsorgepauschale), PAP Seite 19  */
  MZTABFB() {
    this.internals.ANP= BigDecimal.ZERO();
    if (this.internals.ZVBEZ.compareTo (BigDecimal.ZERO()) >= 0 && this.internals.ZVBEZ.compareTo(this.internals.FVBZ) == -1) {
      
        this.internals.FVBZ = BigDecimal.valueOf(this.internals.ZVBEZ.longValue());
      
    }
    if (this.inputs.STKL < 6) {
      
        if (this.internals.ZVBEZ.compareTo (BigDecimal.ZERO()) == 1) {
          
            if ((this.internals.ZVBEZ.subtract (this.internals.FVBZ)).compareTo (BigDecimal.valueOf (102)) == -1) {
              
                this.internals.ANP= (this.internals.ZVBEZ.subtract (this.internals.FVBZ)).setScale (0, BigDecimal.ROUND_UP);
              
              }else {
                this.internals.ANP= BigDecimal.valueOf (102);
              
            }
          
        }
      
      }else {
        this.internals.FVBZ= BigDecimal.valueOf (0);
        this.internals.FVBZSO= BigDecimal.valueOf (0);
      
    }
    if (this.inputs.STKL < 6) {
      
        if (this.internals.ZRE4.compareTo(this.internals.ZVBEZ) == 1) {
          
            if (this.internals.ZRE4.subtract(this.internals.ZVBEZ).compareTo(ZAHL1000) == -1) {
              
                this.internals.ANP = this.internals.ANP.add(this.internals.ZRE4).subtract(this.internals.ZVBEZ).setScale(0,BigDecimal.ROUND_UP);
              
              }else {
                this.internals.ANP = this.internals.ANP.add(ZAHL1000);
              
            }
          
        }
      
    }
    this.internals.KZTAB= 1;
    if (this.inputs.STKL == 1) {
      
        this.internals.SAP= BigDecimal.valueOf (36);
        this.internals.KFB= (this.inputs.ZKF.multiply (BigDecimal.valueOf (7008))).setScale (0, BigDecimal.ROUND_DOWN);
      
    }else {
      if (this.inputs.STKL == 2) {
          
              this.internals.EFA= BigDecimal.valueOf (1308);
              this.internals.SAP= BigDecimal.valueOf (36);
              this.internals.KFB= (this.inputs.ZKF.multiply (BigDecimal.valueOf (7008))).setScale (0, BigDecimal.ROUND_DOWN);
          
     
          }else {
          if (this.inputs.STKL == 3) {
              
                  this.internals.KZTAB= 2;
                  this.internals.SAP= BigDecimal.valueOf (36);
                  this.internals.KFB= (this.inputs.ZKF.multiply (BigDecimal.valueOf (7008))).setScale (0, BigDecimal.ROUND_DOWN);
              
          
            }else {
                if (this.inputs.STKL == 4) {
                  
                    this.internals.SAP= BigDecimal.valueOf (36);
                    this.internals.KFB= (this.inputs.ZKF.multiply (BigDecimal.valueOf (3504))).setScale (0, BigDecimal.ROUND_DOWN);
                   
                
                }else {
                    if (this.inputs.STKL == 5) {
                      
                        this.internals.SAP= BigDecimal.valueOf (36);
                        this.internals.KFB= BigDecimal.ZERO();
                       
                    
                    }else {
                        this.internals.KFB= BigDecimal.ZERO();
                    
                  }
               
              }
              
          }    
          
      }  
      
    }
    this.internals.ZTABFB= (this.internals.EFA.add (this.internals.ANP).add (this.internals.SAP).add (this.internals.FVBZ)).setScale (2, BigDecimal.ROUND_DOWN);
  }



  /**  Ermittlung Jahreslohnsteuer, PAP Seite 20  */
  MLSTJAHR() {
     this.UPEVP();
    if (this.internals.KENNVMT != 1) {
      
        this.internals.ZVE= (this.internals.ZRE4.subtract (this.internals.ZTABFB).subtract (this.internals.VSP)).setScale (2, BigDecimal.ROUND_DOWN);
        this.UPMLST();
      
      }else {
        this.internals.ZVE= (this.internals.ZRE4.subtract (this.internals.ZTABFB).subtract (this.internals.VSP).subtract ((this.inputs.VMT).divide (ZAHL100)).subtract ((this.inputs.VKAPA).divide (ZAHL100))).setScale (2, BigDecimal.ROUND_DOWN);
        if (this.internals.ZVE.compareTo (BigDecimal.ZERO()) == -1) {
          
             this.internals.ZVE = this.internals.ZVE.add(this.inputs.VMT.divide(ZAHL100)).add(this.inputs.VKAPA.divide(ZAHL100)).divide(ZAHL5).setScale(2,BigDecimal.ROUND_DOWN);
            this.UPMLST();
            this.internals.ST= (this.internals.ST.multiply (ZAHL5)).setScale (0, BigDecimal.ROUND_DOWN); 
          
          }else {
            this.UPMLST();
          this.internals.STOVMT= this.internals.ST;
            this.internals.ZVE= (this.internals.ZVE.add(((this.inputs.VMT.add (this.inputs.VKAPA)).divide (ZAHL500)))).setScale (2, BigDecimal.ROUND_DOWN);
            this.UPMLST();
            this.internals.ST= (((this.internals.ST.subtract (this.internals.STOVMT)).multiply (ZAHL5)).add (this.internals.STOVMT)).setScale (0, BigDecimal.ROUND_DOWN); 
          
        }
      
    } 
  }
  
  /**  PAP Seite 21  */ 
  UPVKVLZZ() {
   this.UPVKV();
   this.internals.JW = this.internals.VKV;
   this.UPANTEIL();
   this.outputs.VKVLZZ = this.internals.ANTEIL1;
  }

  /**  PAP Seite 21  */ 
  UPVKV() {
   if (this.inputs.PKV > 0) {
    
      if (this.internals.VSP2.compareTo(this.internals.VSP3) == 1) {
        
          this.internals.VKV = this.internals.VSP2.multiply(ZAHL100);
        
        }else {
          this.internals.VKV = this.internals.VSP3.multiply(ZAHL100);
        
      }
    
    }else {
      this.internals.VKV = BigDecimal.ZERO();
    
  }
  }
  
  /**  PAP Seite 22  */
   UPLSTLZZ() {
       this.internals.JW = this.internals.LSTJAHR.multiply(ZAHL100);
    this.UPANTEIL();
    this.outputs.LSTLZZ = this.internals.ANTEIL1;
   }
  
  
  /**  Ermittlung der Jahreslohnsteuer aus dem Einkommensteuertarif. PAP Seite 22  */
  UPMLST() {
  if (this.internals.ZVE.compareTo (ZAHL1) == -1) {
      
        this.internals.ZVE= BigDecimal.ZERO();
        this.internals.X= BigDecimal.ZERO();
      
      }else {
        this.internals.X= (this.internals.ZVE.divide (BigDecimal.valueOf(this.internals.KZTAB))).setScale (0, BigDecimal.ROUND_DOWN);
      
    }
  if (this.inputs.STKL < 5) {
      
        this.UPTAB14(); 
      
      }else {
        this.MST5_6();
      
    }
  }    


  
  /**    Vorsorgepauschale (§ 39b Absatz 2 Satz 5 Nummer 3 und Absatz 4 EStG)
        Achtung: Es wird davon ausgegangen, dass  
          a) Es wird davon ausge-gangen, dassa) this.inputs.für die BBG (Ost) 60.000 Euro und this.inputs.für die BBG (West) 71.400 Euro festgelegt wird sowie
          b) der Beitragssatz zur Rentenversicherung auf 18,9 % gesenkt wird.
        
        PAP Seite 23   */
  UPEVP() {
    if (this.inputs.KRV > 1) {/**  &lt; = < &gt; = >  */
      
        this.internals.VSP1= BigDecimal.ZERO();
      
    }else {  
      /**  Neu 2015 Anfang  */
        if (this.internals.ZRE4VP.compareTo(this.internals.BBGRV) == 1) {
            
              this.internals.ZRE4VP = this.internals.BBGRV;
            
          }
          this.internals.VSP1 = (this.internals.TBSVORV.multiply(this.internals.ZRE4VP)).setScale(2,BigDecimal.ROUND_DOWN);
          this.internals.VSP1 = (this.internals.VSP1.multiply(this.internals.RVSATZAN)).setScale(2,BigDecimal.ROUND_DOWN);
         /**  Neu 2015 Ende  */ 
      
    }
    this.internals.VSP2 = (this.internals.ZRE4VP.multiply(BigDecimal.valueOf(0.12))).setScale(2,BigDecimal.ROUND_DOWN);
    if (this.inputs.STKL == 3) {
      
          this.internals.VHB = BigDecimal.valueOf(3000);
      
      }else {
          this.internals.VHB = BigDecimal.valueOf(1900);
      
     }
    if (this.internals.VSP2.compareTo (this.internals.VHB) == 1) {
      
        this.internals.VSP2= this.internals.VHB;
      
    }
    this.internals.VSPN= (this.internals.VSP1.add (this.internals.VSP2)).setScale (0, BigDecimal.ROUND_UP);
    this.MVSP();
    if (this.internals.VSPN.compareTo (this.internals.VSP) == 1) {
      
        this.internals.VSP= this.internals.VSPN.setScale (2, BigDecimal.ROUND_DOWN);
      
    }
  }
 

  /**  Achtung !!! Komplett Neu 2015  */
  /**  Vorsorgepauschale (§39b Abs. 2 Satz 5 Nr 3 EStG) Vergleichsberechnung fuer Guenstigerpruefung, PAP Seite 24  */
  MVSP() {
    if (this.internals.ZRE4VP.compareTo(this.internals.BBGKVPV) == 1) {
      
      this.internals.ZRE4VP = this.internals.BBGKVPV;
    
    }

    if (this.inputs.PKV > 0) {
      
          if (this.inputs.STKL == 6) {
            
            this.internals.VSP3 = BigDecimal.ZERO();
          
          }else {
              this.internals.VSP3 = this.inputs.PKPV.multiply(ZAHL12).divide(ZAHL100);
            if (this.inputs.PKV == 2) {
                
                  this.internals.VSP3 = this.internals.VSP3.subtract( this.internals.ZRE4VP.multiply( this.internals.KVSATZAG.add(this.internals.PVSATZAG))).setScale(2,BigDecimal.ROUND_DOWN);
                        
            }
          
          }
      
      }else {
        this.internals.VSP3 = this.internals.ZRE4VP.multiply(this.internals.KVSATZAN.add(this.internals.PVSATZAN)).setScale(2, BigDecimal.ROUND_DOWN);
      
    }
    this.internals.VSP = this.internals.VSP3.add(this.internals.VSP1).setScale(0, BigDecimal.ROUND_UP);
  }

  /**    */
  UMVSP() {
    this.internals.VSPVOR = (this.internals.VSPVOR.subtract(this.internals.ZRE4VP.multiply(BigDecimal.valueOf(0.16)))).setScale(2, BigDecimal.ROUND_DOWN);
    if (this.internals.VSPVOR.compareTo(BigDecimal.ZERO()) == -1) {
      
        this.internals.VSPVOR = BigDecimal.ZERO();
      
    }
    if (this.internals.VSPO.compareTo(this.internals.VSPVOR) == 1) {
      
        this.internals.VSP = this.internals.VSPVOR;
        this.internals.VSPREST = this.internals.VSPO.subtract(this.internals.VSPVOR);
        if (this.internals.VSPREST.compareTo(this.internals.VSPMAX1) == 1) {
          
            this.internals.VSP = this.internals.VSP.add(this.internals.VSPMAX1);
            this.internals.VSPREST = (this.internals.VSPREST.subtract(this.internals.VSPMAX1)).divide(ZAHL2, 2,BigDecimal.ROUND_UP);
            if (this.internals.VSPREST.compareTo(this.internals.VSPMAX2) == 1) {
              
                this.internals.VSP = (this.internals.VSP.add(this.internals.VSPMAX2)).setScale(0,BigDecimal.ROUND_DOWN);
              
              }else {
                this.internals.VSP = (this.internals.VSP.add(this.internals.VSPREST)).setScale(0,BigDecimal.ROUND_DOWN);
              
            }
          
          }else {
            this.internals.VSP = (this.internals.VSP.add(this.internals.VSPREST)).setScale(0, BigDecimal.ROUND_DOWN);
          
        }
      
      }else {
        this.internals.VSP = this.internals.VSPO.setScale(0, BigDecimal.ROUND_DOWN);
      
    }
  }

  /**  Lohnsteuer fuer die Steuerklassen V und VI (§ 39b Abs. 2 Satz 7 EStG), PAP Seite 25  */
  MST5_6() {
    this.internals.ZZX= this.internals.X;
    if (this.internals.ZZX.compareTo (BigDecimal.valueOf (26441)) == 1) {
      
        this.internals.ZX= BigDecimal.valueOf (26441);
        this.UP5_6();
      if (this.internals.ZZX.compareTo (BigDecimal.valueOf (200584)) == 1) {
        
            this.internals.ST= (this.internals.ST.add ((BigDecimal.valueOf (200584).subtract (BigDecimal.valueOf (26441))).multiply (BigDecimal.valueOf (0.42)))).setScale (0, BigDecimal.ROUND_DOWN);
            this.internals.ST= (this.internals.ST.add ((this.internals.ZZX.subtract (BigDecimal.valueOf (200584))).multiply (BigDecimal.valueOf (0.45)))).setScale (0, BigDecimal.ROUND_DOWN);
          
          }else {
            this.internals.ST= (this.internals.ST.add ((this.internals.ZZX.subtract (BigDecimal.valueOf (26441))).multiply (BigDecimal.valueOf (0.42)))).setScale (0, BigDecimal.ROUND_DOWN);
          
        }
      
      }else {
        this.internals.ZX= this.internals.ZZX;
        this.UP5_6();
        if (this.internals.ZZX.compareTo (BigDecimal.valueOf (9763)) == 1) { 
          
            this.internals.VERGL= this.internals.ST;
            this.internals.ZX= BigDecimal.valueOf (9763); 
            this.UP5_6();
            this.internals.HOCH= (this.internals.ST.add ((this.internals.ZZX.subtract (BigDecimal.valueOf (9763))).multiply (BigDecimal.valueOf (0.42)))).setScale (0, BigDecimal.ROUND_DOWN); /**  Neuer Wert 2014  */
            if (this.internals.HOCH.compareTo (this.internals.VERGL) == -1) {
              
                this.internals.ST= this.internals.HOCH;
              
              }else {
                this.internals.ST= this.internals.VERGL;
              
            }
          
        }
      
    }
  }

  
  
  /**  Unterprogramm zur Lohnsteuer fuer die Steuerklassen V und VI (§ 39b Abs. 2 Satz 7 EStG), PAP Seite 26  */
  UP5_6() {
    this.internals.X= (this.internals.ZX.multiply (BigDecimal.valueOf (1.25))).setScale (2, BigDecimal.ROUND_DOWN);
    this.UPTAB14(); 
    this.internals.ST1= this.internals.ST;
    this.internals.X= (this.internals.ZX.multiply (BigDecimal.valueOf (0.75))).setScale (2, BigDecimal.ROUND_DOWN);
    this.UPTAB14(); 
    this.internals.ST2= this.internals.ST;
    this.internals.DIFF= (this.internals.ST1.subtract (this.internals.ST2)).multiply (ZAHL2);
    this.internals.MIST= (this.internals.ZX.multiply (BigDecimal.valueOf (0.14))).setScale (0, BigDecimal.ROUND_DOWN);
    if (this.internals.MIST.compareTo (this.internals.DIFF) == 1) {
      
        this.internals.ST= this.internals.MIST;
      
      }else {
        this.internals.ST= this.internals.DIFF;
      
    }
  }



  /**  Solidaritaetszuschlag, PAP Seite 27  */
  MSOLZ() {
    this.internals.SOLZFREI= BigDecimal.valueOf (972 * this.internals.KZTAB);
    if (this.internals.JBMG.compareTo (this.internals.SOLZFREI) == 1) {
      
        this.internals.SOLZJ= (this.internals.JBMG.multiply (BigDecimal.valueOf (5.5))).divide(ZAHL100).setScale(2, BigDecimal.ROUND_DOWN);
        this.internals.SOLZMIN= (this.internals.JBMG.subtract (this.internals.SOLZFREI)).multiply (BigDecimal.valueOf (20)).divide (ZAHL100).setScale (2, BigDecimal.ROUND_DOWN);
        if (this.internals.SOLZMIN.compareTo (this.internals.SOLZJ) == -1) {
          
            this.internals.SOLZJ= this.internals.SOLZMIN;
          
        }
        this.internals.JW= this.internals.SOLZJ.multiply (ZAHL100).setScale (0, BigDecimal.ROUND_DOWN);
        this.UPANTEIL();
        this.outputs.SOLZLZZ= this.internals.ANTEIL1;
      
      }else {
        this.outputs.SOLZLZZ= BigDecimal.ZERO();
      
    }
    if (this.inputs.R > 0) {
      
        this.internals.JW= this.internals.JBMG.multiply (ZAHL100);
        this.UPANTEIL();
        this.outputs.BK= this.internals.ANTEIL1;
      
      }else {
        this.outputs.BK= BigDecimal.ZERO();
      
    }
  }



  /**  Anteil von Jahresbetraegen fuer einen this.inputs.LZZ (§ 39b Abs. 2 Satz 9 EStG), PAP Seite 28  */
  UPANTEIL() {
    if (this.inputs.LZZ == 1) {
      
        this.internals.ANTEIL1= this.internals.JW;
      
      }else {
        if (this.inputs.LZZ == 2) {
          
            this.internals.ANTEIL1= this.internals.JW.divide (ZAHL12, 0, BigDecimal.ROUND_DOWN);
          
          }else {
            if (this.inputs.LZZ == 3) {
               
                this.internals.ANTEIL1= (this.internals.JW.multiply (ZAHL7)).divide (ZAHL360, 0, BigDecimal.ROUND_DOWN);
              
              }else {
                this.internals.ANTEIL1= this.internals.JW.divide (ZAHL360, 0, BigDecimal.ROUND_DOWN);
              
            }
          
        }
      
    }
  }



  /**  Berechnung sonstiger Bezuege nach § 39b Abs. 3 Saetze 1 bis 8 EStG), PAP Seite 29  */
  MSONST() {
    this.inputs.LZZ= 1;
    if (this.inputs.ZMVB == 0) {
      
        this.inputs.ZMVB= 12;
      
    }
    if (this.inputs.SONSTB.compareTo (BigDecimal.ZERO()) == 0) {
      
        this.outputs.VKVSONST= BigDecimal.ZERO();
        this.internals.LSTSO= BigDecimal.ZERO();
        this.outputs.STS= BigDecimal.ZERO();
        this.outputs.SOLZS= BigDecimal.ZERO();
        this.outputs.BKS= BigDecimal.ZERO();
      
      }else {
        this.MOSONST();
        this.UPVKV();
        this.outputs.VKVSONST = this.internals.VKV;
        this.internals.ZRE4J= ((this.inputs.JRE4.add (this.inputs.SONSTB)).divide (ZAHL100)).setScale (2, BigDecimal.ROUND_DOWN);
        this.internals.ZVBEZJ= ((this.inputs.JVBEZ.add (this.inputs.VBS)).divide (ZAHL100)).setScale (2, BigDecimal.ROUND_DOWN);
        this.internals.VBEZBSO= this.inputs.STERBE;
        this.MRE4SONST();
        this.MLSTJAHR();
        this.UPVKV();
        this.outputs.VKVSONST = this.internals.VKV.subtract(this.outputs.VKVSONST);
        this.internals.LSTSO= this.internals.ST.multiply (ZAHL100);
        /**    lt. PAP muss hier auf ganze EUR aufgerundet werden, 
              allerdings muss der Wert in Cent vorgehalten werden,
              deshalb nach dem Aufrunden auf ganze EUR durch 'divide(ZAHL100, 0, BigDecimal.ROUND_DOWN)'
              wieder die Multiplikation mit 100  */
        this.outputs.STS = this.internals.LSTSO.subtract(this.internals.LSTOSO).multiply(BigDecimal.valueOf(this.inputs.f)).divide(ZAHL100, 0, BigDecimal.ROUND_DOWN).multiply(ZAHL100);
        if (this.outputs.STS.compareTo (BigDecimal.ZERO()) == -1) {
          
            this.outputs.STS= BigDecimal.ZERO();
          
        }
        this.outputs.SOLZS= this.outputs.STS.multiply (BigDecimal.valueOf (5.5)).divide (ZAHL100, 0, BigDecimal.ROUND_DOWN);
        if (this.inputs.R > 0) {
          
            this.outputs.BKS= this.outputs.STS;
          
          }else {
            this.outputs.BKS= BigDecimal.ZERO();
          
        }
      
    }
  }



  /**  Berechnung der Verguetung fuer mehrjaehrige Taetigkeit nach § 39b Abs. 3 Satz 9 und 10 EStG), PAP Seite 30  */
  MVMT() {
    if (this.inputs.VKAPA.compareTo (BigDecimal.ZERO()) == -1) {
      
        this.inputs.VKAPA= BigDecimal.ZERO();
      
    }
    if ((this.inputs.VMT.add (this.inputs.VKAPA)).compareTo (BigDecimal.ZERO()) == 1) {
      
        if (this.internals.LSTSO.compareTo (BigDecimal.ZERO()) == 0) {
          
            this.MOSONST();
            this.internals.LST1= this.internals.LSTOSO;
          
          }else {
            this.internals.LST1= this.internals.LSTSO;
          
        }
        this.internals.VBEZBSO= this.inputs.STERBE.add (this.inputs.VKAPA);
        this.internals.ZRE4J= ((this.inputs.JRE4.add (this.inputs.SONSTB).add (this.inputs.VMT).add (this.inputs.VKAPA)).divide (ZAHL100)).setScale (2, BigDecimal.ROUND_DOWN);
        this.internals.ZVBEZJ= ((this.inputs.JVBEZ.add (this.inputs.VBS).add (this.inputs.VKAPA)).divide (ZAHL100)).setScale (2, BigDecimal.ROUND_DOWN);
        this.internals.KENNVMT = 2;
        this.MRE4SONST();
        this.MLSTJAHR();
        this.internals.LST3= this.internals.ST.multiply (ZAHL100);
        this.MRE4ABZ();
        this.internals.ZRE4VP = this.internals.ZRE4VP.subtract(this.inputs.JRE4ENT.divide(ZAHL100)).subtract(this.inputs.SONSTENT.divide(ZAHL100));
        this.internals.KENNVMT= 1;
        this.MLSTJAHR();
        this.internals.LST2= this.internals.ST.multiply (ZAHL100);
        this.outputs.STV= this.internals.LST2.subtract (this.internals.LST1); 
        this.internals.LST3= this.internals.LST3.subtract (this.internals.LST1);
        if (this.internals.LST3.compareTo (this.outputs.STV) == -1) {
          
            this.outputs.STV= this.internals.LST3;
          
        }
        if (this.outputs.STV.compareTo (BigDecimal.ZERO()) == -1) {
          
            this.outputs.STV= BigDecimal.ZERO();
          
          }else {
            /**   
              lt. PAP muss hier auf ganze EUR abgerundet werden.
               Allerdings muss auch hier der Wert in Cent vorgehalten werden,
              weshalb nach dem Aufrunden auf ganze EUR durch 'divide(ZAHL100, 0, BigDecimal.ROUND_DOWN)'
              wieder die Multiplikation mit 100 erfolgt.
             */
            this.outputs.STV = this.outputs.STV.multiply(BigDecimal.valueOf(this.inputs.f)).divide(ZAHL100, 0, BigDecimal.ROUND_DOWN).multiply(ZAHL100);
          
        }
        this.outputs.SOLZV= ((this.outputs.STV.multiply (BigDecimal.valueOf (5.5))).divide (ZAHL100)).setScale (0, BigDecimal.ROUND_DOWN);
        if (this.inputs.R > 0) {
          
            this.outputs.BKV= this.outputs.STV;
          
          }else {
            this.outputs.BKV= BigDecimal.ZERO();
          
        }
      
      }else { 
        this.outputs.STV= BigDecimal.ZERO();
        this.outputs.SOLZV= BigDecimal.ZERO();
        this.outputs.BKV= BigDecimal.ZERO();
      
    }
  }



  /**  Sonderberechnung ohne sonstige Bezüge this.inputs.für Berechnung bei sonstigen Bezügen oder Vergütung this.inputs.für mehrjährige Tätigkeit, PAP Seite 31  */
  MOSONST() {
    this.internals.ZRE4J= (this.inputs.JRE4.divide (ZAHL100)).setScale (2, BigDecimal.ROUND_DOWN);
    this.internals.ZVBEZJ= (this.inputs.JVBEZ.divide (ZAHL100)).setScale (2, BigDecimal.ROUND_DOWN);
    this.internals.JLFREIB= this.inputs.JFREIB.divide (ZAHL100, 2, BigDecimal.ROUND_DOWN);
    this.internals.JLHINZU= this.inputs.JHINZU.divide (ZAHL100, 2, BigDecimal.ROUND_DOWN);
    this.MRE4();
    this.MRE4ABZ();
    this.internals.ZRE4VP = this.internals.ZRE4VP.subtract(this.inputs.JRE4ENT.divide(ZAHL100));
    this.MZTABFB();
    this.MLSTJAHR();
    this.internals.LSTOSO= this.internals.ST.multiply (ZAHL100);
  }



  /**  Sonderberechnung mit sonstige Bezüge this.inputs.für Berechnung bei sonstigen Bezügen oder Vergütung this.inputs.für mehrjährige Tätigkeit, PAP Seite 29  */
  MRE4SONST() {
    this.MRE4();
    this.internals.FVB= this.internals.FVBSO;
    this.MRE4ABZ();
    this.internals.ZRE4VP = this.internals.ZRE4VP.subtract(this.inputs.JRE4ENT.divide(ZAHL100)).subtract(this.inputs.SONSTENT.divide(ZAHL100));
    this.internals.FVBZ= this.internals.FVBZSO;
    this.MZTABFB();
  }
  
  


   /**  Tarifliche Einkommensteuer §32a EStG, PAP Seite 32  */
  UPTAB14() {
    if (this.internals.X.compareTo (BigDecimal.valueOf (8355)) == -1) { 
      
        this.internals.ST= BigDecimal.ZERO();
      
      }else {
        if (this.internals.X.compareTo (BigDecimal.valueOf (13470)) == -1) {
          
            this.internals.Y= (this.internals.X.subtract (BigDecimal.valueOf (8354))).divide (BigDecimal.valueOf (10000), 6, BigDecimal.ROUND_DOWN); 
            this.internals.RW= this.internals.Y.multiply (BigDecimal.valueOf (974.58)); 
            this.internals.RW= this.internals.RW.add (BigDecimal.valueOf (1400));
            this.internals.ST= (this.internals.RW.multiply (this.internals.Y)).setScale (0, BigDecimal.ROUND_DOWN);
          
          }else {
            if (this.internals.X.compareTo (BigDecimal.valueOf (52882)) == -1) {
              
                this.internals.Y= (this.internals.X.subtract (BigDecimal.valueOf (13469))).divide (BigDecimal.valueOf (10000), 6, BigDecimal.ROUND_DOWN);
                this.internals.RW= this.internals.Y.multiply (BigDecimal.valueOf (228.74));
                this.internals.RW= this.internals.RW.add (BigDecimal.valueOf (2397));
                this.internals.RW= this.internals.RW.multiply (this.internals.Y);
                this.internals.ST= (this.internals.RW.add (BigDecimal.valueOf (971))).setScale (0, BigDecimal.ROUND_DOWN); 
              
              }else {
              if (this.internals.X.compareTo (BigDecimal.valueOf (250731)) == -1) {
                
                    this.internals.ST= ((this.internals.X.multiply (BigDecimal.valueOf (0.42))).subtract (BigDecimal.valueOf (8239))).setScale (0, BigDecimal.ROUND_DOWN); 
                  
                  }else {
                    this.internals.ST= ((this.internals.X.multiply (BigDecimal.valueOf (0.45))).subtract (BigDecimal.valueOf (15761))).setScale (0, BigDecimal.ROUND_DOWN); 
                  
                }
              
            }
          
        }
      
    }
    this.internals.ST= this.internals.ST.multiply (BigDecimal.valueOf (this.internals.KZTAB));
  }
  

}

Lohnsteuer2015Big.TAB1 = TAB1;
Lohnsteuer2015Big.TAB2 = TAB2;
Lohnsteuer2015Big.TAB3 = TAB3;
Lohnsteuer2015Big.TAB4 = TAB4;
Lohnsteuer2015Big.TAB5 = TAB5;
Lohnsteuer2015Big.ZAHL0 = ZAHL0;
Lohnsteuer2015Big.ZAHL1 = ZAHL1;
Lohnsteuer2015Big.ZAHL2 = ZAHL2;
Lohnsteuer2015Big.ZAHL3 = ZAHL3;
Lohnsteuer2015Big.ZAHL4 = ZAHL4;
Lohnsteuer2015Big.ZAHL5 = ZAHL5;
Lohnsteuer2015Big.ZAHL6 = ZAHL6;
Lohnsteuer2015Big.ZAHL7 = ZAHL7;
Lohnsteuer2015Big.ZAHL8 = ZAHL8;
Lohnsteuer2015Big.ZAHL9 = ZAHL9;
Lohnsteuer2015Big.ZAHL10 = ZAHL10;
Lohnsteuer2015Big.ZAHL11 = ZAHL11;
Lohnsteuer2015Big.ZAHL12 = ZAHL12;
Lohnsteuer2015Big.ZAHL100 = ZAHL100;
Lohnsteuer2015Big.ZAHL360 = ZAHL360;
Lohnsteuer2015Big.ZAHL500 = ZAHL500;
Lohnsteuer2015Big.ZAHL700 = ZAHL700;
Lohnsteuer2015Big.ZAHL1000 = ZAHL1000;


module.exports = Lohnsteuer2015Big;
  